﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.SharePoint;
using Microsoft.SharePoint.Administration;

namespace ConsolaColeccionesDeSitios
{
    class Program
    {
        static void Main(string[] args)
        {
            EliminarColecciónDeSitios();
            Console.ReadLine();
        }

        static void ObtenerSPSite()
        {
            try
            {
                using (SPSite spsSitio = new SPSite("http://intranet:84/sitios/rrhh"))
                {
                    using (SPWeb spwSitio = spsSitio.OpenWeb())
                    {
                        Console.WriteLine("Nombre del Sitio: {0}",
                        spwSitio.Title);
                        Console.WriteLine(" + Url: {0}",
                        spwSitio.Url);
                        Console.WriteLine(" + Descripción: {0}",
                        spwSitio.Description);
                        Console.WriteLine(" + ¿Es Sitio Raíz?: {0}",
                        spwSitio.IsRootWeb);
                        Console.WriteLine(" + Plantilla de Sitio: {0}",
                        spwSitio.WebTemplate);

                        Console.ReadLine();
                    }
                }
            }
            catch (Exception ex)
            {
                Console.WriteLine("Error en la visualizacón del Sitio: {0}",
                ex.Message);
            }

        }

        static void CrearColecciónDeSitios()
        {
            try{
                SPWebApplication webApp = SPWebApplication.Lookup(new Uri("http://intranet:84/"));
                SPSite nuevoSitio = webApp.Sites.Add(
                    "/sitios/rrhh", 
                    "Recursos Humanos", 
                    "Herramientas de gestión para el departamento de RRHH",
                    Convert.ToUInt32(3082), "STS#0", "dominio\\Administrator", 
                    "dominio\\Administrator", "a@a.com");

                Console.WriteLine("Nueva Colección creada: {0}",
                    nuevoSitio.RootWeb.Title);
                    nuevoSitio.Dispose();
                Console.ReadLine();
            }
            catch (Exception ex)
            {
                Console.WriteLine("Error en la visualizacón del Sitio: {0}", ex.Message);
            }
        }

        static void EliminarColecciónDeSitios()
        {
            try
            {
                if (SPSite.Exists(new Uri("http://win-u6irsic8d95/sitios/rrhh")))
                {
                    using (SPSite spsSitio = new SPSite("http://win-u6irsic8d95/sitios/rrhh"))
                    {
                        spsSitio.Delete();
                        Console.WriteLine("Colección de sitios borrada");
                        Console.ReadLine();
                    }
                }
            }
            catch (Exception ex)
            {
                Console.WriteLine("Error en la visualizacón del Sitio: {0}", ex.Message);
            }

        }
    }
}
