﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.SharePoint;
using Microsoft.SharePoint.Linq;

namespace Listas_Capitulo06
{
    class Program
    {
        static void Main(string[] args)
        {
            //EnumerarListas();
            //CrearLista();
            //ModificarLista();
            //AgregarElemento();
            //EnumerarElementos();
            //EncontrarElementoLinq();
            //EncontrarElementoLinqSPMetal();
            //EncontrarElementoCaml();
            //AgregarDocumento();
        }

        static void EnumerarListas()
        {
            using (SPSite mySite = new SPSite("http://sps"))
            {
                using (SPWeb myWeb = mySite.OpenWeb())
                {
                    SPListCollection myListColl = myWeb.Lists;

                    foreach (SPList unaLista in myListColl)
                    {
                        Console.WriteLine(unaLista.Title + " - " + unaLista.Fields.Count.ToString() + " - " + unaLista.Hidden.ToString());

                        if (unaLista.Title == "Documentos compartidos")
                        {
                            foreach (SPField unCampo in unaLista.Fields)
                            {
                                if(unCampo.Hidden == false && unCampo.ReadOnlyField == false)
                                Console.WriteLine("   - " + unCampo.Title + " - " + unCampo.Required.ToString());
                            }
                        }
                    }
                }
            }
        }

        static void CrearLista()
        {
            using (SPSite mySite = new SPSite("http://sps"))
            {
                using (SPWeb myWeb = mySite.OpenWeb())
                {
                    SPListCollection myListColl = myWeb.Lists;
                    Guid nuevaListaGuid = myListColl.Add("Una Lista", "Una prueba de lista", SPListTemplateType.GenericList);
                    SPList nuevaLista = myListColl.GetList(nuevaListaGuid, true);
                    nuevaLista.Fields.Add("UnCampo", SPFieldType.Text, false);
                    nuevaLista.Update();
                }
            }
        }

        static void ModificarLista()
        {
            using (SPSite mySite = new SPSite("http://sps"))
            {
                using (SPWeb myWeb = mySite.OpenWeb())
                {
                    SPListCollection myListColl = myWeb.Lists;
                    SPList myLista = myListColl["Una Lista"];
                    myLista.OnQuickLaunch = true;
                    myLista.Update();

                    SPView myVista = myLista.Views["Todos los elementos"];
                    myVista.ViewFields.Add("UnCampo");
                    myVista.Update();
                }
            }
        }

        static void AgregarElemento()
        {
            using (SPSite mySite = new SPSite("http://sps"))
            {
                using (SPWeb myWeb = mySite.OpenWeb())
                {
                    SPListCollection myListColl = myWeb.Lists;
                    SPList myLista = myListColl["Una Lista"];
                    SPListItem nuevoElemento = myLista.Items.Add();
                    nuevoElemento["Title"] = "Primer Elemento";
                    nuevoElemento["UnCampo"] = "Elemento numero uno";
                    nuevoElemento.Update();
                }
            }
        }

        static void EnumerarElementos()
        {
            using (SPSite mySite = new SPSite("http://sps"))
            {
                using (SPWeb myWeb = mySite.OpenWeb())
                {
                    SPListCollection myListColl = myWeb.Lists;
                    SPList myLista = myListColl["Una Lista"];
                    Console.WriteLine("Numero de Elementos - " + myLista.Items.Count.ToString());

                    foreach (SPListItem unElemento in myLista.Items)
                    {
                        Console.WriteLine(unElemento["Title"].ToString() + " - " + unElemento["UnCampo"].ToString());
                    }
                }
            }
        }

        static void EncontrarElementoLinq()
        {
            using (SPSite mySite = new SPSite("http://sps"))
            {
                using (SPWeb myWeb = mySite.OpenWeb())
                {
                    SPListCollection myListColl = myWeb.Lists;
                    SPList myLista = myListColl["Una Lista"];
                    var ElementosEncontrados = from SPListItem unElemento in myLista.Items
                                               where unElemento.Title == "Primer Elemento"
                                               orderby unElemento["UnCampo"]
                                               ascending
                                               select unElemento;

                    foreach (SPListItem myElemento in ElementosEncontrados)
                    {
                        Console.WriteLine(myElemento["UnCampo"]);
                    }
                }
            }
        }

        static void EncontrarElementoLinqSPMetal()
        {
            SPLinqDataContext myDataContexto = new SPLinqDataContext("http://sps");
            EntityList<Elemento> ElementosUnaLista = myDataContexto.GetList<Elemento>("Una Lista");
            var ElementosEncontrados = from unElemento in ElementosUnaLista
                                       where unElemento.Título == "Primer Elemento"
                                       select unElemento;

            foreach (Elemento unElemento in ElementosEncontrados)
            {
                Console.WriteLine(unElemento.Título);
            }
        }

        static void EncontrarElementoCaml()
        {
            using (SPSite mySite = new SPSite("http://sps"))
            {
                using (SPWeb myWeb = mySite.OpenWeb())
                {
                    SPListCollection myListColl = myWeb.Lists;
                    SPList myLista = myListColl["Una Lista"];
                    SPQuery myConsulta = new SPQuery();
                    myConsulta.Query = @"<Where><Contains><FieldRef Name='Title'/><Value Type='Text'>Primer Elemento</Value></Contains></Where>";
                    SPListItemCollection ElementosEncontrados = myLista.GetItems(myConsulta);

                    foreach (SPListItem myElemento in ElementosEncontrados)
                    {
                        Console.WriteLine(myElemento["UnCampo"]);
                    }
                }
            }
        }

        static void AgregarDocumento()
        {
            string Origen = "c:\\test.docx";

            System.IO.FileStream miStream = new System.IO.FileStream(Origen, System.IO.FileMode.Open, System.IO.FileAccess.Read);
            System.IO.BinaryReader miReader = new System.IO.BinaryReader(miStream);
            byte[] arrFileBytes = miReader.ReadBytes((int)miStream.Length);
            miReader.Close();
            miStream.Close();

            string Destino = "http://sps/Documentos compartidos/test.docx";

            System.Net.WebClient miWebClient = new System.Net.WebClient();
            miWebClient.Credentials = System.Net.CredentialCache.DefaultCredentials;
            miWebClient.UploadData(Destino, "PUT", arrFileBytes);
        }
    }
}
