﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using Microsoft.SharePoint;

namespace SharePoint_Sites
{
    class Program
    {
        static void Main(string[] args)
        {
            //GestionarSitios("V");
            //GestionarSitios("C");
            //GestionarSitios("U");
            GestionarSitios("D");
        }
        /// <summary>
        /// Función que permite realizar la gestión de Sitios de SharePoint: Visualizar, Crear, Actualizar, Borrar.
        /// </summary>
        /// <param name="sOpcion">Opción de gestión: V (Visualizar), C (Crear), U (Actualizar), D (Borrar)</param>
        public static void GestionarSitios(string sOpcion)
        {
            switch (sOpcion)
            {
                case "V":
                    try
                    {
                        using (SPSite spsSitio =
                            new SPSite(
                                "http://sagitario/SitioInformatica/"))
                        {
                            using (SPWeb spwSitio =
                            spsSitio.OpenWeb())
                            {
                                //Datos del Sitio
                                Console.WriteLine("Nombre del Sitio: {0}",
                                    spwSitio.Title);
                                Console.WriteLine(" + Url: {0}",
                                    spwSitio.Url);
                                Console.WriteLine(" + Descripción: {0}",
                                    spwSitio.Description);
                                Console.WriteLine(" + ¿Es Sitio Raíz?: {0}",
                                    spwSitio.IsRootWeb);
                                Console.WriteLine(" + Tema del Sitio: {0}",
                                    spwSitio.Theme);
                            }
                        }
                    }
                    catch (Exception ex)
                    {
                        Console.WriteLine(
                            "Error en la visualizacón del Sitio: {0}",
                            ex.Message);
                    }
                    break;

                case "C":
                    try
                    {
                        using (SPSite spsSitio =
                            new SPSite(
                                "http://sagitario/SitioInformatica/"))
                        {
                            using (SPWeb spwSitio =
                                spsSitio.OpenWeb())
                            {

                                SPWebCollection spwcColeccionWebs =
                                    spwSitio.Webs;
                                SPWeb spwNuevoSitio =
                                    spwcColeccionWebs.Add(
                                    "DeptDesarrollo",
                                    "Departamento de Desarrollo",
                                    "Sitio del departamento de desarrollo",
                                    Convert.ToUInt32(3082), "STS#0",
                                    false, false);

                                foreach (SPWeb spwSite in spwcColeccionWebs)
                                {
                                    try
                                    {
                                        //Datos del Sitio
                                        Console.WriteLine("Nombre del Sitio: {0}",
                                            spwSite.Title);
                                        Console.WriteLine(" + Url: {0}",
                                            spwSite.Url);
                                        Console.WriteLine(" + Descripción: {0}",
                                            spwSite.Description);
                                    }
                                    catch (Exception ex)
                                    {
                                        Console.WriteLine(
                                            "Error en la lectura de propiedades del Sitio: {0}",
                                            ex.Message);
                                    }
                                }
                            }
                        }
                    }
                    catch (Exception ex)
                    {
                        Console.WriteLine(
                            "Error en la creación del Sitio: {0}",
                            ex.Message);
                    }
                    break;

                case "U":
                    try
                    {
                        using (SPSite spsSitio =
                            new SPSite(
                                "http://sagitario/"))
                        {
                            using (SPWeb spwSitio =
                                spsSitio.OpenWeb("SitioInformatica/DeptDesarrollo"))
                            {
                                spwSitio.Title = "Dpto. Desarrollo";
                                spwSitio.Update();
                            }
                        }
                        Console.WriteLine(
                            "Sitio actualizado con éxito");
                    }
                    catch (Exception ex)
                    {
                        Console.WriteLine(
                            "Error en la actualización del Sitio: {0}",
                            ex.Message);
                    }
                    break;

                case "D":
                    try
                    {
                        using (SPSite spsSitio =
                            new SPSite("http://sagitario/"))
                        {
                            using (SPWeb spwSitio =
                                spsSitio.OpenWeb("SitioInformatica/DeptDesarrollo"))
                            {
                                spwSitio.Delete();
                            }
                        }
                        Console.WriteLine(
                            "Sitio borrado con éxito");
                    }
                    catch (Exception ex)
                    {
                        Console.WriteLine(
                            "Error en el borrado del Sitio: {0}",
                            ex.Message);
                    }
                    break;

                default:
                    break;
            }
            Console.ReadLine();

        }
    }
}
