﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

//Modelo de objetos en cliente, implementación .NET
using MO_NET = Microsoft.SharePoint.Client;


namespace MOCliente_NET
{
    public partial class frmMONet : Form
    {
        public frmMONet()
        {
            InitializeComponent();
        }
        /// <summary>
        /// Permite consultar las listas disponibles en el sitio.
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btnConsultar_Click(object sender, EventArgs e)
        {
            try
            {
                DataTable dtColeccionListas =
                    new DataTable();
                dtColeccionListas.Columns.Add("Title");
                dtColeccionListas.Columns.Add("Id");
                dtColeccionListas.Columns.Add("Nº Elementos");
                using (MO_NET.ClientContext ctx =
                    new MO_NET.ClientContext(txtUrlSitio.Text))
                {
                    MO_NET.Web wSitio = ctx.Web;
                    ctx.Load(wSitio, oSitio => oSitio.Title);
                    MO_NET.ListCollection lcLists = wSitio.Lists;
                    IEnumerable<MO_NET.List> lcListsCollection =
                        ctx.LoadQuery(lcLists);
                    ctx.ExecuteQuery();

                    lblNumeroListas.Text =
                        "El número de listas contenidas en el Sitio " +
                        wSitio.Title + " es " +
                        lcListsCollection.Count().ToString();

                    foreach (MO_NET.List l in lcListsCollection)
                    {
                        DataRow dtRow = dtColeccionListas.NewRow();
                        dtRow["Title"] = l.Title;
                        dtRow["Id"] = l.Id;
                        dtRow["Nº Elementos"] = l.ItemCount;
                        dtColeccionListas.Rows.Add(dtRow);
                    }
                    grdListas.DataSource = dtColeccionListas;
                }
            }
            catch (MO_NET.InvalidQueryExpressionException ex)
            {
                MessageBox.Show(ex.Message, "¡Error!",
                    MessageBoxButtons.OK,
                    MessageBoxIcon.Error);
            }
            catch (MO_NET.ClientRequestException ex)
            {
                MessageBox.Show(ex.Message, "¡Error!",
                    MessageBoxButtons.OK,
                    MessageBoxIcon.Error);
            }
            catch (MO_NET.PropertyOrFieldNotInitializedException ex)
            {
                MessageBox.Show(ex.Message, "¡Error!",
                    MessageBoxButtons.OK,
                    MessageBoxIcon.Error);
            }
            catch (MO_NET.ServerUnauthorizedAccessException ex)
            {
                MessageBox.Show(ex.Message, "¡Error!",
                    MessageBoxButtons.OK,
                    MessageBoxIcon.Error);
            }
            catch (MO_NET.ServerException ex)
            {
                MessageBox.Show(ex.Message, "¡Error!",
                    MessageBoxButtons.OK,
                    MessageBoxIcon.Error);
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message, "¡Error!",
                    MessageBoxButtons.OK,
                    MessageBoxIcon.Error);
            }

        }
    }
}
