﻿using System;
using System.IO;
using Microsoft.SharePoint;
using Microsoft.SharePoint.Administration;

namespace ContadorDeElementos
{
    public class JobContadorElementos : SPJobDefinition
    {
        public JobContadorElementos()
        {
        }

        //public JobContadorElementos(string MyJobName, SPService MyService, SPServer MyServer, SPJobLockType MyTargetType) : base(MyJobName, MyService, MyServer, MyTargetType) 
        //{
        //}

        public JobContadorElementos(string MyJobName, SPWebApplication MyWebApplication) : base(MyJobName, MyWebApplication, null, SPJobLockType.Job) 
        {
        }

        public override void Execute(Guid ContentDataBaseID) 
        {
            try
            {
                using (SPSite mySite = new SPSite("http://sps"))
                {
                    using (SPWeb myWeb = mySite.OpenWeb())
                    {
                        SPList myList = myWeb.Lists["MyJobs"];

                        int intCounter = 0;
                        foreach (SPListItem myItem in myList.Items)
                            intCounter++;

                        SPListItem newTask = myList.Items.Add();
                        newTask["Title"] = "Contador de Items a la fecha: " + DateTime.Now.ToString();
                        newTask["Description"] = "A las " + DateTime.Now.ToString() + " hay " + intCounter.ToString() +
                                                 " elementos en la lista";
                        newTask.Update();
                    }
                }
            }
            catch (Exception ex)
            {
                TextWriter myWriter = new StreamWriter(@"c:\JobContadorElementosError.txt");
                myWriter.WriteLine(ex.ToString());
                myWriter.Close();
            }
        }
    }
}
