﻿using System;
using System.Security.Permissions;
using Microsoft.SharePoint;
using Microsoft.SharePoint.Security;
using Microsoft.SharePoint.Utilities;
using Microsoft.SharePoint.Workflow;
using Microsoft.SharePoint.Administration;
using System.Configuration;
using System.Web.Configuration;
using System.IO;

namespace ManejadorDeEventos.CreadorVinculos
{
    public class ClaseCreadorVinculos : SPItemEventReceiver
    {
       public override void ItemAdded(SPItemEventProperties properties)
       {
           base.ItemAdded(properties);
           string miListaVinculos = RetornarConfiguracion(properties.SiteId, "NombreListaVinculos");

           try
           {
               using (SPSite miSite = new SPSite(properties.SiteId))
               {
                   using (SPWeb miWeb = miSite.OpenWeb())
                   {
                       SPList miLista = miWeb.Lists[miListaVinculos];
                       SPListItem miVinculo = miLista.Items.Add();
                       miVinculo["URL"] = properties.WebUrl + "/" + properties.ListItem.Url + ", " + properties.ListItem.Name;
                       this.EventFiringEnabled = false;
                       miVinculo.Update();
                       this.EventFiringEnabled = true;
                   }
               }
           }
           catch (Exception ex)
           {
               TextWriter miEscribidor = new StreamWriter(@"c:\ManejadorEventosError.txt");
               miEscribidor.WriteLine(ex.ToString());
               miEscribidor.Close();
           }
       }

       private string RetornarConfiguracion(Guid SitioId, string NombreClave)
       {
           string strReturn = string.Empty;

           using (SPSite mySite = new SPSite(SitioId))
           {
               SPWebApplication myWebApp = mySite.WebApplication;
               Configuration myConfig = WebConfigurationManager.OpenWebConfiguration("/", myWebApp.Name);
               strReturn = myConfig.AppSettings.Settings[NombreClave].Value;
           }

           return strReturn;
       }
    }
}
