﻿using System;
using Microsoft.SharePoint;

namespace InstaladorDeEvento
{
    class Program
    {
        static void Main(string[] args)
        {
            InstalarEvento();
        }

        static void InstalarEvento()
        {
            using (SPSite miSitio = new SPSite("http://sps"))
            {
                using (SPWeb miWeb = miSitio.OpenWeb())
                {
                    SPList miLista = miWeb.Lists["Documentos compartidos"];

                    SPEventReceiverDefinitionCollection misReceptoresEventos = miLista.EventReceivers;
                    SPEventReceiverDefinition miEvento = misReceptoresEventos.Add();

                    miEvento.Assembly = "ManejadorDeEventos, Version=1.0.0.0, Culture=neutral, PublicKeyToken=b8eeb44144fc0156";
                    miEvento.Name = "Manejador Eventos CreadorVinculos";
                    miEvento.Type = SPEventReceiverType.ItemAdded;
                    miEvento.SequenceNumber = 10000;
                    miEvento.Class = "ManejadorDeEventos.CreadorVinculos.ClaseCreadorVinculos";

                    miEvento.Update();

                    foreach (SPEventReceiverDefinition miDef in
                      misReceptoresEventos)
                    {
                        Console.WriteLine(miDef.Name);
                    }
                }
            }
        }
    }
}
