﻿using System;
using Microsoft.SharePoint;
using Microsoft.SharePoint.Administration;

namespace ManejoDeJobs
{
    class Program
    {
        static void Main(string[] args)
        {
            //CrearJob();
            //EnumerarTodosLosJobs();
            EliminarJob();
            EnumerarTodosLosJobs();
        }

        static void EnumerarTodosLosJobs()
        {
            using (SPSite mySite = new SPSite("http://sps"))
            {
                foreach (SPJobDefinition oneJob in mySite.WebApplication.JobDefinitions)
                {
                    Console.WriteLine(oneJob.Title + " - " +
                        oneJob.LastRunTime.ToLongTimeString() + " - " +
                        oneJob.Schedule.GetType().ToString().Remove(0, 21));
                }
            }
        }

        static void CrearJob()
        {
            SPServer myServer = SPServer.Local;
            using (SPSite mySite = new SPSite("http://sps"))
            {
                SPWebApplication myApplication = mySite.WebApplication;
                SPJobDefinitionCollection myJobsColl = myApplication.JobDefinitions;

                SPJobDefinition myJob = new mySPJobDefinition("TestJobFalso", myApplication, myServer, SPJobLockType.Job);
                myJob.Title = "Test Job Falso";

                SPDailySchedule myDailySchedule = new SPDailySchedule();
                myDailySchedule.BeginHour = 3;
                myDailySchedule.BeginMinute = 0;
                myDailySchedule.BeginSecond = 0;
                myJob.Schedule = myDailySchedule;

                myJobsColl.Add(myJob);
                myApplication.Update();

                Console.WriteLine("Job Instalado");
            }
        }

        static void EliminarJob()
        {
            using (SPSite mySite = new SPSite("http://sps"))
            {
                foreach (SPJobDefinition oneJob in mySite.WebApplication.JobDefinitions)
                {
                    if (oneJob.Title == "Test Job Falso")
                    {
                        oneJob.Delete();
                        Console.WriteLine("Job Eliminado");
                    }
                }
            }
        }

        static void EliminarJob2()
        {
            Guid myId = new Guid();

            using (SPSite mySite = new SPSite("http://sps"))
            {
                SPWebApplication myApplication = mySite.WebApplication;
                SPJobDefinitionCollection myJobsColl = myApplication.JobDefinitions;

                foreach (SPJobDefinition oneJob in mySite.WebApplication.JobDefinitions)
                {
                    if (oneJob.Title == "Test Job Falso")
                        myId = oneJob.Id;
                }

                myJobsColl.Remove(myId);
                myApplication.Update();

                Console.WriteLine("Job Eliminado");
            }
        }
    }

    class mySPJobDefinition : SPJobDefinition
    {
        public mySPJobDefinition()
            : base()
        {
        }

        public mySPJobDefinition(string NombreJob, SPWebApplication AplicacionWeb, SPServer ServerLocal, SPJobLockType TipoJob)
            : base(NombreJob, AplicacionWeb, ServerLocal, TipoJob)
        {
            this.Title = NombreJob;
        }
    }
}
