using System;
using System.Runtime.InteropServices;
using System.Security.Permissions;
using Microsoft.SharePoint;
using Microsoft.SharePoint.Security;

//Espacios de nombres necesarios
using System.Globalization;

namespace SPCustomActionsFeature.Features.SPCustomActionFeature
{
    /// <summary>
    /// This class handles events raised during feature activation, deactivation, installation, uninstallation, and upgrade.
    /// </summary>
    /// <remarks>
    /// The GUID attached to this class may be used during packaging and should not be modified.
    /// </remarks>

    [Guid("7ee360a6-d967-4477-80d2-eddb8db28439")]
    public class SPCustomActionFeatureEventReceiver : SPFeatureReceiver
    {
        // Uncomment the method below to handle the event raised after a feature has been activated.

        public override void FeatureActivated(SPFeatureReceiverProperties properties)
        {
            CultureInfo ciInfo =
                new CultureInfo(3082);
            AgregarElemento(
                (SPSite)properties.Feature.Parent,
                properties.Feature.Definition.GetTitle(ciInfo),
                "Activado");
        }


        // Uncomment the method below to handle the event raised before a feature is deactivated.

        public override void FeatureDeactivating(SPFeatureReceiverProperties properties)
        {
            CultureInfo ciInfo =
                new CultureInfo(3082);
            AgregarElemento(
                (SPSite)properties.Feature.Parent,
                properties.Feature.Definition.GetTitle(ciInfo),
                "Desactivado");
        }

        static void AgregarElemento(
            SPSite spsSitio, string sFeatureTitle, string sEvento)
        {
            using (spsSitio)
            {
                using (SPWeb spwWeb
                    = spsSitio.RootWeb)
                {
                    SPListCollection splcColeccion =
                        spwWeb.Lists;
                    SPList splLista =
                        splcColeccion["Seguimiento de Caracterstica"];
                    SPListItem spliElemento =
                        splLista.Items.Add();
                    spliElemento["Title"] = sFeatureTitle;
                    if (sEvento == "Activado")
                    {
                        spliElemento["Evento"] = "Caracterstica activada";
                    }
                    else
                    {
                        spliElemento["Evento"] = "Caracterstica desactivada";
                    }
                    spliElemento.Update();
                }
            }
        }

        // Uncomment the method below to handle the event raised after a feature has been installed.

        //public override void FeatureInstalled(SPFeatureReceiverProperties properties)
        //{
        //}


        // Uncomment the method below to handle the event raised before a feature is uninstalled.

        //public override void FeatureUninstalling(SPFeatureReceiverProperties properties)
        //{
        //}

        // Uncomment the method below to handle the event raised when a feature is upgrading.

        //public override void FeatureUpgrading(SPFeatureReceiverProperties properties, string upgradeActionName, System.Collections.Generic.IDictionary<string, string> parameters)
        //{
        //}
    }
}
