﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

//Espacios de nombres necesarios
using Microsoft.SharePoint;
using Microsoft.SharePoint.Administration;
using System.Globalization;

namespace SPFeature_OM
{
    class Program
    {
        static void Main(string[] args)
        {
            //ListarFeatures();
            //ListarElementos();
            //ActivarFeature();
            DesactivarFeature();
        }
        /// <summary>
        /// Lista las características de la Colección de Sitios
        /// </summary>
        static void ListarFeatures()
        {
            using (SPSite spsSitio
                = new SPSite("http://sagitario"))
            {
                SPFeatureCollection spfcCaracteristicas =
                    spsSitio.Features;
                CultureInfo ciInfo =
                    new CultureInfo(3082);
                foreach (SPFeature spfCaracteristica in spfcCaracteristicas)
                {
                    if (spfCaracteristica.Definition != null)
                    {
                        Console.WriteLine("Titulo: {0} - Id: {1}",
                            spfCaracteristica.Definition.GetTitle(ciInfo),
                            spfCaracteristica.DefinitionId);
                    }
                }
                Console.ReadLine();
            }
        }

        /// <summary>
        /// Lista los elementos que forman parte de la característica
        /// </summary>
        static void ListarElementos()
        {
            using (SPSite spsSitio
                = new SPSite("http://sagitario"))
            {
                SPFeatureCollection spfcCaracteristicas =
                    spsSitio.Features;
                Guid guidFeature =
                    new Guid("695b6570-a48b-4a8e-8ea5-26ea7fc1d162");
                CultureInfo ciInfo =
                    new CultureInfo(3082);
                SPFeature spFeature = (from spf in spfcCaracteristicas
                                       where spf.DefinitionId == guidFeature
                                       select spf).First();
                SPElementDefinitionCollection spedcElementos =
                    spFeature.Definition.GetElementDefinitions(ciInfo);

                foreach (SPElementDefinition spedElemento in spedcElementos)
                {
                    Console.WriteLine(spedElemento.ElementType.ToString());
                }
                Console.ReadLine();
            }
        }

        /// <summary>
        /// Permite activar una característica
        /// </summary>
        static void ActivarFeature()
        {
            try
            {
                using (SPSite spsSitio
                    = new SPSite("http://sagitario"))
                {
                    SPFeatureCollection spfcCaracteristicas =
                       spsSitio.Features;
                    Guid guidFeature =
                        new Guid("8ed7d8ec-cf4c-448c-b0c0-1710be842d30");
                    spfcCaracteristicas.Add(guidFeature, true);
                    Console.WriteLine(
                        "Característica activada correctamente...");
                }

            }
            catch (Exception ex)
            {
                Console.WriteLine(
                    "Error en la activación de la característica: {0}",
                    ex.Message);
            }
        }

        /// <summary>
        /// Permite desactivar una característica
        /// </summary>
        static void DesactivarFeature()
        {
            try
            {
                using (SPSite spsSitio
                    = new SPSite("http://sagitario"))
                {
                    SPFeatureCollection spfcCaracteristicas =
                       spsSitio.Features;
                    Guid guidFeature =
                        new Guid("8ed7d8ec-cf4c-448c-b0c0-1710be842d30");
                    spfcCaracteristicas.Remove(guidFeature, true);
                    Console.WriteLine(
                        "Característica desactivada correctamente...");
                }

            }
            catch (Exception ex)
            {
                Console.WriteLine(
                    "Error en la desactivación de la característica: {0}",
                    ex.Message);
            }
        }
    }
}
