﻿using System;
using System.ComponentModel;
using System.ComponentModel.Design;
using System.Collections;
using System.Linq;
using System.Workflow.ComponentModel.Compiler;
using System.Workflow.ComponentModel.Serialization;
using System.Workflow.ComponentModel;
using System.Workflow.ComponentModel.Design;
using System.Workflow.Runtime;
using System.Workflow.Activities;
using System.Workflow.Activities.Rules;

using Microsoft.SharePoint.WorkflowActions;

namespace ActividadPersonalizada
{
    public partial class Activity1 : SequenceActivity
    {
        public static DependencyProperty IdentificadorGeneradoProperty = DependencyProperty.Register("IdentificadorGenerado", typeof(string), typeof(Activity1));

        [DescriptionAttribute("Genera un Identificador")]
        [CategoryAttribute("Configuracion del Generador")]
        [BrowsableAttribute(true)]
        [DesignerSerializationVisibilityAttribute(DesignerSerializationVisibility.Visible)]
        public string IdentificadorGenerado
        {
            get
            {
                return ((string)(base.GetValue(Activity1.IdentificadorGeneradoProperty)));
            }
            set
            {
                base.SetValue(Activity1.IdentificadorGeneradoProperty, value);
            }
        }

        public static DependencyProperty InvokeEvent = DependencyProperty.Register("Invoke", typeof(EventHandler), typeof(Activity1));

        [DescriptionAttribute("Metodo Invoke para la Actividad de Generacion")]
        [CategoryAttribute("Configuracion del Generador")]
        [BrowsableAttribute(true)]
        [DesignerSerializationVisibilityAttribute(DesignerSerializationVisibility.Visible)]
        public event EventHandler Invoke
        {
            add
            {
                base.AddHandler(Activity1.InvokeEvent, value);
            }
            remove
            {
                base.RemoveHandler(Activity1.InvokeEvent, value);
            }
        }

        public Activity1()
        {
            InitializeComponent();
        }

        protected override ActivityExecutionStatus Execute(ActivityExecutionContext executionContext)
        {
            IdentificadorGenerado = Guid.NewGuid().ToString();
            base.RaiseEvent(ActividadPersonalizada.Activity1.InvokeEvent, this, EventArgs.Empty);
            return ActivityExecutionStatus.Closed;
            //return base.Execute(executionContext);
        }

        public static bool IdentificadorEsValido(WorkflowContext myFlowContext, string myFlowListId, 
                        int myFlowListItem, string IdentificadorParaValidar)
        {
            bool blnReturn = false;
            Guid myGuid = Guid.Empty;
            try
            {
                TypeDescriptor.GetConverter(myGuid).ConvertFrom(IdentificadorParaValidar);
                blnReturn = true;
            }
            catch { }
            return blnReturn;
        }
    }
}
